
library IEEE;
use IEEE.STD_LOGIC_1164.all;


-- 16 bit register
entity register16 is
    Port ( load : in  STD_LOGIC;
           d : in  STD_LOGIC_VECTOR (15 downto 0);
           clk : in  STD_LOGIC;
           clr : in  STD_LOGIC;
			  q : out  STD_LOGIC_VECTOR (15 downto 0)
);
end register16;

architecture register16 of register16 is
	component reg
	generic (N: integer);
	
	port(
		load : in  STD_LOGIC;
      d : in  STD_LOGIC_VECTOR ((N-1) downto 0);
      clk : in  STD_LOGIC;
      clr : in  STD_LOGIC;
		q : out  STD_LOGIC_VECTOR ((N-1) downto 0)
		);
		end component;	
begin

--instantination
 R1: reg
generic map(N=>16)

port map(
	load=>load,
	d=>d,
	clk=>clk,
	clr=>clr,
	q => q );
		
end register16;